#include <SDL.h>
#include <SDL_image.h>
#include <iostream>

void MostrarFondo(SDL_Surface *surface) {
    // Bandas de color
    SDL_Rect rect = { 0, 0, 80, 480};
    Uint32 color;

    color = SDL_MapRGBA(surface->format, 0, 0, 0, 255);
    SDL_FillRect(surface, &rect, color);

    rect.x += 80;
    color = SDL_MapRGBA(surface->format, 255, 0, 0, 255);
    SDL_FillRect(surface, &rect, color);

    rect.x += 80;
    color = SDL_MapRGBA(surface->format, 255, 255, 0, 255);
    SDL_FillRect(surface, &rect, color);

    rect.x += 80;
    color = SDL_MapRGBA(surface->format, 0, 255, 0, 255);
    SDL_FillRect(surface, &rect, color);

    rect.x += 80;
    color = SDL_MapRGBA(surface->format, 0, 255, 255, 255);
    SDL_FillRect(surface, &rect, color);

    rect.x += 80;
    color = SDL_MapRGBA(surface->format, 0, 0, 255, 255);
    SDL_FillRect(surface, &rect, color);

    rect.x += 80;
    color = SDL_MapRGBA(surface->format, 255, 0, 255, 255);
    SDL_FillRect(surface, &rect, color);

    rect.x += 80;
    color = SDL_MapRGBA(surface->format, 255, 255, 255, 255);
    SDL_FillRect(surface, &rect, color);
}

int main( int argc, char * argv[] ) {
    SDL_Window *ventana;
    SDL_Surface *superficieLoros;
    SDL_Surface *superficieDados;
    SDL_Surface *superficieA;
    SDL_Surface *superficieVentana;
    SDL_Surface *superficieB;
    SDL_Rect orig = {250, 50, 64, 48};
    SDL_Rect re = {0, 0, 32, 24};
    char cad[256];

    SDL_Init(SDL_INIT_EVERYTHING);
    ventana = SDL_CreateWindow(NULL, SDL_WINDOWPOS_CENTERED, SDL_WINDOWPOS_CENTERED,
            640, 480, SDL_WINDOW_SHOWN | SDL_WINDOW_BORDERLESS);
    superficieVentana = SDL_GetWindowSurface(ventana);
    MostrarFondo(superficieVentana);

SDL_Delay(1000);

    superficieLoros = IMG_Load("loroscolor.png");
    superficieA = SDL_CreateRGBSurface(0, superficieLoros->w,superficieLoros->h,32,
        superficieLoros->format->Rmask, superficieLoros->format->Gmask, superficieLoros->format->Bmask, superficieLoros->format->Amask);
    superficieB = SDL_CreateRGBSurface(0, superficieLoros->w,superficieLoros->h,32,
        superficieLoros->format->Rmask, superficieLoros->format->Gmask, superficieLoros->format->Bmask, superficieLoros->format->Amask);
    SDL_BlitSurface(superficieLoros, NULL, superficieA, NULL);

    if(SDL_SoftStretchLinear(superficieA, &orig, superficieB, &re)) {
        SDL_GetErrorMsg(cad, 256);
        std::cout << cad << std::endl;
    }
    SDL_BlitSurface(superficieB, &re, superficieVentana, &re);
    SDL_UpdateWindowSurface(ventana);
SDL_Delay(1000);

    re.x=320;
    re.y=0;
    re.w=320;
    re.h=240;
    SDL_BlitSurface(superficieLoros, &orig, superficieVentana, &re);
    SDL_UpdateWindowSurface(ventana);
SDL_Delay(1000);

    re.x=0;
    re.y=240;
    re.w=320;
    re.h=240;
    SDL_BlitScaled(superficieLoros, &orig, superficieVentana, &re);
    SDL_UpdateWindowSurface(ventana);
SDL_Delay(1000);

    re.x=0;
    re.y=0;
    re.w=320;
    re.h=240;
    if(SDL_SoftStretchLinear(superficieA, &orig, superficieB, &re)) {
        SDL_GetErrorMsg(cad, 256);
        std::cout << cad << std::endl;
    }
    re.x = 320;
    re.y = 240;
    orig.x=0;
    orig.y=0;
    orig.w=320;
    orig.h=240;
    SDL_BlitSurface(superficieB, &orig, superficieVentana, &re);
    SDL_UpdateWindowSurface(ventana);

SDL_Delay(2000);

    superficieDados = IMG_Load("dados.png");
    MostrarFondo(superficieVentana);
    orig.x=0;
    orig.y=0;
    orig.w=superficieDados->w;
    orig.h=superficieDados->h;
    std::cout << "Modo SDL_BLENDMODE_BLEND" << std::endl;
    SDL_SetSurfaceBlendMode(superficieDados, SDL_BLENDMODE_BLEND);
    SDL_BlitSurface(superficieDados, &orig, superficieVentana, NULL);
    SDL_UpdateWindowSurface(ventana);
SDL_Delay(3000);

    MostrarFondo(superficieVentana);
    orig.x=0;
    orig.y=0;
    orig.w=superficieDados->w;
    orig.h=superficieDados->h;
    std::cout << "Modo SDL_BLENDMODE_ADD" << std::endl;
    SDL_SetSurfaceBlendMode(superficieDados, SDL_BLENDMODE_ADD);
    SDL_BlitSurface(superficieDados, &orig, superficieVentana, NULL);
    SDL_UpdateWindowSurface(ventana);
SDL_Delay(3000);

    MostrarFondo(superficieVentana);
    orig.x=0;
    orig.y=0;
    orig.w=superficieDados->w;
    orig.h=superficieDados->h;
    std::cout << "Modo SDL_BLENDMODE_MUL" << std::endl;
    SDL_SetSurfaceBlendMode(superficieDados, SDL_BLENDMODE_MUL);
    SDL_BlitSurface(superficieDados, &orig, superficieVentana, NULL);
    SDL_UpdateWindowSurface(ventana);
SDL_Delay(3000);

    MostrarFondo(superficieVentana);
    orig.x=0;
    orig.y=0;
    orig.w=superficieDados->w;
    orig.h=superficieDados->h;
    std::cout << "Modo SDL_BLENDMODE_MOD" << std::endl;
    SDL_SetSurfaceBlendMode(superficieDados, SDL_BLENDMODE_MOD);
    SDL_BlitSurface(superficieDados, &orig, superficieVentana, NULL);
    SDL_UpdateWindowSurface(ventana);
SDL_Delay(3000);

    MostrarFondo(superficieVentana);
    orig.x=0;
    orig.y=0;
    orig.w=superficieDados->w;
    orig.h=superficieDados->h;
    std::cout << "Modo SDL_BLENDMODE_NONE" << std::endl;
    SDL_SetSurfaceBlendMode(superficieDados, SDL_BLENDMODE_NONE);
    SDL_BlitSurface(superficieDados, &orig, superficieVentana, NULL);
    SDL_UpdateWindowSurface(ventana);
SDL_Delay(3000);

    SDL_FreeSurface(superficieDados);
    SDL_FreeSurface(superficieLoros);
    SDL_FreeSurface(superficieA);
    SDL_FreeSurface(superficieB);
    SDL_DestroyWindowSurface(ventana);
    SDL_DestroyWindow(ventana);
    SDL_Quit();
    return 0;
}
